#!/usr/bin/perl
###
#
# Checkout_pages.pm
#
#
####

###
#
# These functions are taken from Checkout.cgi in an effort to further modularize
# AllCommerce



sub getFirstPage {
# Right now this needs globals

  $cur_page = $_[0];
  $orderid = $_[1];
  $pagelist = $_[2];
  if (!$cur_page ||  !$orderid ) {
     if ($cur_page !~ /display/) {

       $cur_page = $pagelist->{'firstdisplay'}
     }
   }
  return $cur_page
}
sub getPageList {


###########
# 	Page list			function
# 	Shipping Address Page		pg_shippingaddress()
#	Shipping Method Page		pg_shippingmethod()
#	Billing and Payment Pg		pg_billpay()
#	OrderApprove Page		pg_orderapprove()
#	OrderConf	Page		pg_orderconf()
#	EnterAcdress Page		pg_addressenter()
###########


	my $pagelist = {
	   firstdisplay =>		'pg_firstdisplay',
	   shippingaddress => 	 	'pg_shippingaddress',
	   shippingmethod  =>		'pg_shippingmethod',
	   billpay	=>		'pg_billpay',
	   orderapprove	=>		'pg_orderapprove',
	   orderconf	=>		'pg_orderconf',
	   addressenter	=>		'pg_addressenter',
	   ordersummary =>		'pg_ordersummary'
	};

        return $pagelist;
}

sub getCellList {

   
###########
#	Cell List			function
#	Addressbook cell		cl_addressbook()
#	EnterAddress cell		cl_addressedit()
#	Shiping Method cell		cl_shippingmethod()
#  	Billing address and
#	Payment page			cl_billpay()
#   Orderlist				cl_orderlist()
#   Order approval cell		cl_orderapprove()
###########
	$celllist = {
		addressbook	=>		'cl_addressbook',
		addressedit	=>		'cl_addressedit',
		shippingmethod  =>		'cl_shippingmethod',
		billpay		=>		'cl_billpay',
		orderlist	=>  		'cl_orderlist',
		orderapprove	=>		'cl_orderapprove',
		orderemail	=>		'cl_orderemail',
	};


	return $celllist;
}


sub pg_firstdisplay {

      my ($ret_hash)= $_[0];
      $ret_hash->{'template'} = 'page_checkout_firstdisplay';

      ## Make page
      #
      &make_pg_1();
	
      if (!$ret_hash->{'orderid'}) {

         
         $f= " SELECT * FROM tcart where sid='$ret_hash->{'sid'}' and custid='$ret_hash->{'custid'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         
         
         $z=$stf->fetchrow_hashref(NAME_lc);
         $orderid = $z->{'orderid'}; 
         if (!$ret_hash->{'FORM'}->{'addrid'}) {
            	if ($ret_hash->{'addrid'}) {
			$ret_hash->{'FORM'}->{'addrid'}=$ret_hash->{'addrid'};
		} else {
			$ret_hash->{'FORM'}->{'addrid'}=$ret_hash->{'addrid'};
	    	}
         } 	# if we have an addrid from the form data we'll put that into the
         # orders table as well
         
         
         
         $q="INSERT into orders ";
         $q.="(objid,sid,custid,shipto,cdate,mdate,status) ";
         $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'addrid'}',";
         $q.="'$now','$now','15012-A') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $ret_hash->{'orderid'} = $orderid;
	
         push (@{$ret_hash->{'orderid_array'}}, $orderid);
         } else {
         
         foreach $t (@{$ret_hash->{'orderid_array'}}) {
            if (!$ret_hash->{'FORM'}->{'addrid'}) {
               $ret_hash->{'FORM'}->{'addrid'}=$ret_hash->{'addrid'};
            }
            $q = "update orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'addrid'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$t' ";
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
         }
      }

## make_pg_1 - make the output for checkout page 1
#
sub make_pg_1 {


    # steps involved in this process
    #
    # 1) Get everything from tcart
    # 2) Get behavior (stock behavior) for each of these items
    # 3) Select weight_man from things so we know how to display items
    # 4) Get lstock from inventory for each of these items
    # 5) Check if this item has been checked out before, if so,
    #    set everything back
    # 6) Run through behavior logic and see if the user can purchase this item
    # 7) Update tcart
    # 8) Check if quantity error existed, if so,
    #    set everything back 

   $FORM{'page_err'}="" if ( ! $FORM{'page_err'} );

    $q = " SELECT * from tcart where SID='$FORM{'sid'}' and objclass != '140-A' ";
    $stss = $dbh->prepare($q);
    $stss->execute;
#    $num=$stss->rows;
    print ERLOG " Number of rows $num \n";

#    $flag="ok";
    $okflag = 1;
    my $r = 0;
#    foreach $r (1..$num) {
    while ($h=$stss->fetchrow_hashref(NAME_lc)) {
#        $h=$stss->fetchrow_hashref;
        $r++;
        $q=" SELECT behavior, ref_from from things where objid='$h->{'lineobjid'}' ";
        $stq=$dbh->prepare($q);
        $stq->execute;
#        $numq2=$stq->rows;
        ($behavior, $ref_from)=$stq->fetchrow_array;

        if (!$behavior) {
           $q=" SELECT behavior from things where objid='$ref_from' ";
           $stq=$dbh->prepare($q);
           $stq->execute;
           ($behavior)=$stq->fetchrow;
        }


#    while ($h=$stss->fetchrow_hashref(NAME_lc)) {
#        $h=$stss->fetchrow_hashref;
#        $r++;
#        $q=" SELECT behavior from things where objid='$h->{'lineobjid'}' ";
#        $stq=$dbh->prepare($q);
#        $stq->execute;
#        $numq2=$stq->rows;
#        ($behavior)=$stq->fetchrow;

        print ERLOG " q is $q \n";
        print ERLOG " behavior is $behavior \n";

        ## not quite sure why this is used
        #
        $q=" SELECT weight_man from things where objid='$h->{'lineobjid'}' ";
        $q.="and vcode='$h->{'vcode'}' ";
        $stq=$dbh->prepare($q);
        $stq->execute;
#        $numq3=$stq->rows;
        ($weight)=$stq->fetchrow;

        print ERLOG " q is $q \n";
        print ERLOG " weight is $weight \n";

        $q="SELECT lstock from inventory where objid='$h->{'lineobjid'}' ";
        $sth=$dbh->prepare($q);
        $sth->execute;

        ($instock) = $sth->fetchrow;

        print ERLOG " q is $q \n";
        print ERLOG " instock is $instock \n";

        #get price and linetotal
        $clist->{$r}=$h;

#        $p=" SELECT * from prices where objid='$h->{'lineobjid'}' ";
#        $p.="and status='15000-A' ";
#        $stp=$dbh->prepare($p);
#        $stp->execute;
#        $nump=$stp->rows;
#        $pp=$stp->fetchrow_hashref;

#        print ERLOG "p is $p \n";

#        $clist->{$r}->{'unitpr'}=$pp->{'unitpr'};
#        $linetotal=$pp->{'unitpr'}*$h->{'quant'};

#        $clist->{$r}->{'linetotal'}=$linetotal;

         $clist->{$r}->{'unitpr'} = $h->{'unitpr'};
         $clist->{$r}->{'linetotal'} = $h->{'linetotal'};

        # check if this itme has been checked out before,
        # if so, put back everything 
        if ( $ret_hash->{'mode'} eq "SHOW" ) {

#           if ($h->{'hquant'} > 0 || $h->{'squant'} > 0) {
#              &put_tcart_to_inv(); 
#           }
        
           #check behavior and do necessary update 
           &update_inv_and_tcart();
        } 
#        if ($instock > 0  || $behavior eq "90006-A" ) {
#
#           $newstock=$instock - $h->{'quant'};
#
#           print ERLOG " newstock is $newstock \n";
#
#           if ($instock > 0) {

              # fix this nelson
              # when updating from inventory we should always do an increment or decrement!
              # create an event first
              # insert in to events dvalue, dtable "updating inventory";

              # ie. update inventory set lstock=+3

#              $q= "UPDATE inventory SET lstock='-$h->{'quant'}' ";
#              $q.=" where objid='$h->{'lineobjid'}' ";
#
#              $dbh->do($q);

#              $q= "UPDATE tcart set squant='$h->{'quant'}' where objid='$h->{'objid'}' ";
#              $q.="and objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
#              $q.="and custid='$h->{'custid'}' ";
#              $dbh->do($q);

#              print ERLOG "update cart with inventory \n q is $q \n";
#           }

#           $flag="ok";

#        } else {

#           $h->{'quant_err'}="We're really sorry, but this item has just
#              recently gone out of stock "; }

#           $clist->{$r}=$h;

#           $p=" SELECT * from prices where objid='$h->{'lineobjid'}' ";
#           $p.="and status='15000-A' ";
#           $stp=$dbh->prepare($p);
#           $stp->execute;
#           $nump=$stp->rows;
#           $pp=$stp->fetchrow_hashref;

#           print ERLOG "p is $p \n";

#           $clist->{$r}->{'unitpr'}=$pp->{'unitpr'};
#           $linetotal=$pp->{'unitpr'}*$h->{'quant'};

#           $clist->{$r}->{'linetotal'}=$linetotal;

#           if ($instock > 0 || $behavior eq "90006-A" ) {
#
#             $q=" UPDATE tcart set linetotal='$linetotal', unitpr='$pp->{'unitpr'}' "; 
#              $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
#              $q.="and custid='$h->{'custid'}' ";
#              $stq=$dbh->prepare($q);
#              $stq->execute;
#
#              print ERLOG "update cart with new prices\n q is $q \n";
#           }

       # Get title for product
       $t=" SELECT * from things where objid='$h->{'lineobjid'}' ";
       $stt=$dbh->prepare($t);
       $stt->execute;
#       $tt=$stt->fetchrow_hashref;
       $vcode="";
       $vardescript="";

       while ( $nh = $stt->fetchrow_hashref(NAME_lc) ) {
           if ( $nh->{'objid'} ne $nh->{'ref_from'} && $nh->{'ref_from'} ) {
               $vcode = $nh->{'vcode'};
               $q="SELECT * from things where objid='$nh->{'ref_from'}' ";                     $stq=$dbh->prepare( $q );
               $stq->execute;
#                     $num=$stq->rows;
               $mh=$stq->fetchrow_hashref(NAME_lc);

               @vcodes = split /:/, $vcode;
               @axisname = split /:/, $mh->{'axisnames'};
               foreach $axis (@axisname) {
                   $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                   $stl=$dbh->prepare($s);
                   $stl->execute;
                   ($body)=$stl->fetchrow;
                   @valuepairs = split /\r\n/, $body;
                   foreach $pair (@valuepairs) {
                       ($key,$value) = split/:/, $pair;
                       $variant{$key}=$value;
                   }
                   $code = shift @vcodes;
                   $vardescript.=" ".$variant{$code};
               }
#               $nh->{'title'} = $mh->{'title'}.$vardescript;
#               $clist->{$r}->{'title'}=$nh->{'title'};
               $clist->{$r}->{'title'}=$mh->{'title'}.$vardescript;
            } else {
               $clist->{$r}->{'title'}=$nh->{'title'};
            }
       }
       print ERLOG "title is $clist->{$r}->{'title'} \n";
       $okflag = 0 if ($h->{'quant_err'});
   } #/done updating cart and decrementing inventory

   $x = ( keys %{$clist} );
   ## load templates and generate page
   #

   $FORM{'cell_ck_300_finalhdr'} =
   loadtemplate( "cell_ck_300_finalhdr","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html");

   $FORM{'cell_ck_300_finallist'} =
   loadtemplate("cell_ck_300_finallist","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html");

   $FORM{'cell_ck_300_p1_btn'} = loadtemplate("cell_ck_300_p1_btn_continue", "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html");

#    if ($flag eq "notok") {
#
#       $FORM{'cell_ck_300_p1_btn'} = loadtemplate
#       ("cell_ck_300_p1_btn_2", "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html"); }

   $u=loadtemplate("cell_ck_300_finallist","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html");
   $o="";
   $st=0;

   foreach $r ( keys %{$clist} ) {
      ## fix number of zeros after the decimal point for some fields
      #
      foreach $k ("linetotal","unitpr" ) {
         $clist->{$r}->{$k} = nicedecimals( $clist->{$r}->{$k} );
      } # done with decimal point cleanup

      $du = permutebit( $u, $clist->{$r} );
      $o.=$du;
      $st+=$clist->{$r}->{'linetotal'} if ( $clist->{$r}->{'quant'}>0 );
   } # done building list items   

   $FORM{'cell_ck_300_finallist'}=$o;

   $FORM{'subtotal'} = nicedecimals( $st );

   # If any quantity error existed, put hquant, squant and lstock to
   # original number
   if (!$okflag) {
#       &put_tcart_to_inv();
       $FORM{'cell_ck_300_p1_btn'} = loadtemplate("cell_ck_300_p1_btn_cart", "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/eng/html");
   }


#   sub put_tcart_to_inv {
#       $q = " SELECT * from tcart where SID='$FORM{'sid'}' and objclass != '140-A' ";
#       $sttt = $dbh->prepare($q);
#       $sttt->execute;
#       while ($back = $sttt->fetchrow_hashref(NAME_lc)) {

#           $q = " SELECT lstock from inventory ";
#           $q.= "where objid='$back->{'lineobjid'}' ";
#           $sttq = $dbh->prepare($q);
#           $sttq->execute;
#           ($instock) = $sttq->fetchrow;

#           $instock += $back->{'hquant'};
#           $q= "UPDATE inventory SET lstock=lstock+$h->{'hquant'} ";
#           $q.=" where objid='$h->{'lineobjid'}' ";
#           $sts = $dbh->prepare($q);
#           $sts->execute;

#           $q = "UPDATE tcart set hquant='0', squant='0' ";
#           $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
#           $q.="and custid='$h->{'custid'}' ";
#           $sts = $dbh->prepare($q);
#           $sts->execute;
#       }
#    }

    sub update_inv_and_tcart {
        ## run through behavior logic and see if the user can purchase this item

        # nelson - please fix this logic for me
                               
        #90002-A| JIT Saleable if no stock
        #check to see if quant of items are availavle from lstock
        #if they are, decrement from lstock move to hquant
        #else decrement from lstock move to squant
        #partial move avilable items to hquant, all others move to squant

        #90005-A| Potentially restockable if no stock (if out of stock, don't sell)
        #check to see if quant of items are available from lstock
        #if they are, decrement from lstock move to hquant
        #else "error message - you cannot buy this item at this time, it is out of stock.

        #90006-A| Saleable irrespective of stock
        #check to see if quant of items are availavle from lstock
        #if they are, decrement from lstock move to hquant
        #else decrement from lstock move to squant
        #partial move avilable items to hquant, all others move to squant

        #90007-A| Discontinued
        #check to see if quant of items are availavle from lstock
        #if they are, decrement from lstock move to hquant
        #check to see if quant of items are available from lstock
        #if they are, decrement from lstock move to hquant
        #else "error message - you cannot buy this item at this time, it is out of stock.

        #90008-A| Recalled
        #do not sell even if inventory exists

        # the below routines are wrong.
       # Nelson's part

       # For all the behavior besides Recalled,
       # if the quantity of local stock is more than the quantity of the order,
       # decrement lstock by quantity ordered in inventory
       # and move quantity ordered to hquant
       if ($instock >= $h->{'quant'} && ($behavior ne "90008-A")) {
              $instock -= $h->{'quant'};
              $q= "UPDATE inventory SET lstock='$instock' ";
              $q.=" where objid='$h->{'lineobjid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute; 

              $q = "UPDATE tcart set hquant='$h->{'quant'}' ";
#              $q.="linetotal='$linetotal', unitpr='$pp->{'unitpr'}' ";
              $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
              $q.="and custid='$h->{'custid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute;

       } else {
           if ($behavior eq "90002-A"){
              $squant = $h->{'quant'} - $instock;
              $q= "UPDATE inventory SET lstock='0' ";
              $q.=" where objid='$h->{'lineobjid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute;

              $q= "UPDATE tcart set hquant='$instock', squant='$squant' ";
#              $q.="linetotal='$linetotal', unitpr='$pp->{'unitpr'}' ";
              $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
              $q.="and custid='$h->{'custid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute;
           }
           elsif ($behavior eq "90005-A"){
              $h->{'quant_err'} = "We are really sorry, but we just have $instock of this item in stock currently.";
           }
           elsif ($behavior eq "90006-A"){
              $squant = $h->{'quant'} - $instock;
              $q= "UPDATE inventory SET lstock='0' ";
              $q.=" where objid='$h->{'lineobjid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute;

              $q= "UPDATE tcart set hquant='$instock', squant='$squant' ";
#              $q.="linetotal='$linetotal', unitpr='$pp->{'unitpr'}' ";
              $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
              $q.="and custid='$h->{'custid'}' ";
              $sts = $dbh->prepare($q);
              $sts->execute;
           }
           elsif ($behavior eq "90007-A"){
              $h->{'quant_err'} = "We are really sorry, but we just have $instock of this item in stock currently."
           }
       }

       if ($behavior eq "90008-A"){
          $h->{'quant_err'} = "We are really sorry, but this item is no longer available.";
       }
    }

   return 1;
} #/make_pg_1


   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash->{'func'} = 'firstdisplay';
      $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);

   } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
        $ret_hash->{'func'} = 'firstdisplay';
      $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);  
      $ret_hash->{'mode'}='SHOW'; 
      if (!$ret_hash->{'ERROR'}) {
    
         $ret_hash->{'DISPLAY'} = 'shippingaddress';
      } else {
         $ret_hash->{'DISPLAY'} = 'firstdisplay';
      }
      



   }

   return $ret_hash;
}
sub pg_shippingaddress {

   ###########
   # pg_shippingaddress	Shipping Address Page
   #
   # Requires:
   #	sid
   #	custid
   # 	orderid
   #	state
   # 	FIELDS if orderid contains
   
   # Modes
   #	input		Displays fields, permutes page cell
   #	approve		passes to cell approval process
   
   # Cells
   #	cl_addressbook
   #	cl_addressedit
   
   # Function
   #   when it recieves an addrid from any cell contained within and a success
   #   flag it will insert it into orders and move on to next page.
   
   # Outputs as hashref:
   #	Hash of values
   # 	name of template
   # 	Error conditions
   #   mode
   
   
   my $ret_hash = $_[0];
   $ret_hash->{'addrid_type'} = 'shipto';
   $ret_hash->{'template'} = 'page_checkout_shipping_list';
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      #######
      # ret_hash should now contain all the form info
      # if it doesn't goto show and display old with info if succesfull
      # we should have addrid from cell and can store that in the order
      #
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      # Check for error
      
      if (!$ret_hash{'addrid'}) {
         $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);
      }
      
     
      } elsif ($ret_hash->{'mode'} eq 'SHOW') {
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
      $ret_hash->{'DISPLAY'} = 'shippingaddress';
      } else {
      
   }
   if (!$ret_hash->{'ERROR'} && $ret_hash->{'mode'} eq 'APPROVE' && ($ret_hash->{'FORM'}->{'addrid'} || $ret_hash->{'addrid'}) && $ret_hash->{'func'} ne 'delete' ) {
      ## it worked
      $ret_hash->{'addrid'} = $ret_hash->{'FORM'}->{'addrid'} if (!$ret_hash->{'addrid'}); 
      $ret_hash->{'mode'} = 'SHOW';
      ## get new orderid if we don't have one
    
            $q = "UPDATE orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'addrid'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$ret_hash->{'orderid'}' ";
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute; 
#      $q = "SELECT * FROM tcart where sid = '$ret_hash->{'sid'}'";
#      $sth=$dbh->prepare($q);
#      $sth->execute;
#      $rows = $sth->rows;
#      if ($rows > 0) {
#         for (1..$rows)
#         {
            #inventory_reserve($h);
            
#         }
#      }
      ## now we figure out what our next page is
      if ($ret_hash->{'FORM'}->{'nextpage'}) {
         ## this will be set by a cell
         
         $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
         } else {
         ## our default will be shipping method
         $ret_hash->{'DISPLAY'} = 'shippingmethod';
      }
      } else {
      ## we must have got an error, default to show and lets go back again to
      ##shipping address
      $ret_hash->{'mode'} = 'SHOW';
      $ret_hash->{'DISPLAY'} = 'shippingaddress';
   }
   return $ret_hash;
   
   
}


sub pg_shippingmethod {

   ###########
   # pg_shippingmethod		Shipping Method Page

#
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields if orderid active
   
   
   # Function
   #	when it recieves as shipping sku from the cell it will add to an an ordid line in orders
   #	then move to next page. Else it will dispaly an error
   
   # Cells
   #	cl_shippingmethod
   
   # Modes
   #	input
   #	approve
   
   ############
   
   my $ret_hash = $_[0];
   my %backhash = ();
   my %lines = ();
   #my $now;
   $ret_hash->{'template'} = 'page_checkout_shippingmethod';
   #$now = time();
   
   ##create new orderid
   ## What we need to do is go item by item and reserve inventory
   ## and figure out whether we can ship something now or if it
   ## is going to be a backorder
   
   ## First we get teh stuff from the tcart
   

   if ($ret_hash->{'mode'} eq 'SHOW'){
      
       if (!$ret_hash->{'orderid'}) {

         
         $f= " SELECT * FROM tcart where sid='$ret_hash->{'sid'}' and custid='$ret_hash->{'custid'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         
         
         $z=$stf->fetchrow_hashref(NAME_lc);
         $orderid = $z->{'orderid'}; 
         if (!$ret_hash->{'FORM'}->{'addrid'}) {
            	if ($ret_hash->{'addrid'}) {
			$ret_hash->{'FORM'}->{'addrid'}=$ret_hash->{'addrid'};
		} else {
			$ret_hash->{'FORM'}->{'addrid'}=$ret_hash->{'addrid'};
	    	}
         } 	# if we have an addrid from the form data we'll put that into the
         # orders table as well
         
         
         
         $q="INSERT into orders ";
         $q.="(objid,sid,custid,shipto,cdate,mdate,status) ";
         $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'addrid'}',";
         $q.="'$now','$now','15012-A') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $ret_hash->{'orderid'} = $orderid;
	
         push (@{$ret_hash->{'orderid_array'}}, $orderid);
         } else {
         foreach $t (@{$ret_hash->{'orderid_array'}}) {
            $q = "update orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'addrid'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$t' ";
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
         }
      }


      ## back the routine ... if the mode is show than the shipping method is show
      $ret_hash = &{$celllist->{'shippingmethod'}}($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      # or approve
      $ret_hash = &{$celllist->{'shippingmethod'}}($ret_hash);
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      # if we have approve now we need to show
      $ret_hash->{'mode'} = 'SHOW';
      
   }
   if (!$ret_hash->{'ERROR'}) {
      
      
      ## other wise we use ordersummary
      $ret_hash->{'DISPLAY'} = 'ordersummary';
      } else {
      
      ## but if we have an error, we go back to shipping method
      $ret_hash->{'DISPLAY'} = 'shippingmethod';
   }
   return $ret_hash;
   
   
   
   
   
}

sub pg_billpay {

   ###########
   # pg_billpay			Billing address and Payment Page
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields
   #	mode
   
   # Modes
   #	input
   #	approve
   
   # Cells
   #	cl_addressenter
   #	cl_addressbook
   #	cl_billpay
   
   # Function
   #	Update billaddress if nescessary
   #	store billing info
   
   
   
   
   my ($orderid);
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_billpay';
   $ret_hash->{'addrid_type'} = 'billto';
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      #######
      # ret_hash should now contain all the form info
      # if it doesn't goto show and display old with info if succesfull
      # we should have addrid from cell and can store that in the order
      #
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      
      # Check for error
      $ret_hash->{'FORM'}->{'func'}='billto';
      
      $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);
      if ($ret_hash->{'addrid'}) {$ret_hash->{'FORM'}->{'addrid'} = $ret_hash->{'addrid'};}
      
	
      if (!$ret_hash->{'ERROR'} && $ret_hash->{'FORM'}->{'addrid'}) {
         ## okay we checked the addesses and got
         ## Success now we save addrid to bilto in orders
         foreach $orderid (@{$ret_hash->{'orderid_array'}}) {
            $q = "update orders set billto = '$ret_hash->{'FORM'}->{'addrid'}' where objid = '$orderid'";
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
         }
      }
      
      
      
      $ret_hash->{'FORM'}->{'func'}='billto';
      if (! $ret_hash->{'ERROR'} ) {
         $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);
      }
      
      
      if (!$ret_hash->{'ERROR'}) {
         
         $ret_hash = &{$celllist->{'billpay'}} ($ret_hash);
         
      }
      if (!$ret_hash->{'ERROR'}) {
	 $ret_hash =  &{$celllist->{'orderapprove'}} ($ret_hash);   
      
      }


      if ( $ret_hash->{'ERROR'} ) {
#         $ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCID_inp'}="";
      }

      } elsif ($ret_hash->{'mode'} eq 'SHOW') {
      
      ## we have four cells on this page
      ## addressbook, orderlist, addressedit and billpay
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      
      #$ret_hash = &{$celllist->{'orderlist'}} ($ret_hash);
      
      $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);

      
      $ret_hash = &{$celllist->{'billpay'}} ($ret_hash);
      

      $ret_hash = &{$celllist->{'orderapprove'}} ($ret_hash);    
      
      
      
      } else {
      ## bad if we get here as we default to SHOW if no mode is found
   }
   
   # Insert cell handling
   
   ## same next page handling as before
   ## no errror we go to orderapprove else
   ## we go back, with the exception being we
   ## can say what page we want to go to next

   if ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash->{'mode'} = 'SHOW';
  
      if ($ret_hash->{'ERROR'} =~ /success/){

         foreach $order ( @{$ret_hash->{'orderid_array'}} ) {
            my %FORM = %{$ret_hash->{'FORM'}};
            &tcart_to_ocart($ret_hash->{'sid'},$order,$ret_hash->{'custid'}, $nextwh, $testing ); #
            $q = "UPDATE orders SET status='15018-A' where objid = '$order'";
            $q = "UPDATE orders SET status='15020-A' where objid = '$order'" if ( $site->{'payprocess'} ne "none" );       
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
            #create an event with a success in the dvalue
            $l="SELECT  wh FROM tcart where orderid='$order' ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            ($wh)=$stl->fetchrow;
            if (!$sidwh) {
               $sidwh=$wh;
            }
            $dvalue=$order."\t".$ret_hash->{'cyberoid'}."\tno\tuc\t".$ret_hash->{'STATUSDVALUE'};
            if ( $site->{'site_datadriver'} =~ /Oracle/ ) {
               $l="INSERT INTO levents (event,DTABLE,DVALUE,CDATE,custid) VALUES (levents_event.nextval,'addresses','$dvalue','$now','$ret_hash->{'custid'}') ";
            } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {
               $l="INSERT INTO levents (DTABLE, DVALUE, CDATE,CUSTID) VALUES ('addresses','$dvalue','$now','$ret_hash->{'custid'}')"; 
            } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {
               $l="INSERT INTO levents (event,DTABLE,DVALUE,CDATE,custid) VALUES (NEXTVAL('event'),'addresses','$dvalue','$now','$ret_hash->{'custid'}') "; 
            }

            $stl=$dbh->prepare($l);
            $stl->execute;
            $ok_proceed=1;
            
            
            
            $q="Select WH FROM ocart where orderid = '$order'";
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $num=$sth->rows;
#            for (1 .. $num) {
            while ( $wh = $sth->fetchrow ) {
#               $wh = $sth->fetchrow;
               $wh_hash->{$order}->{$wh} = 1;
            }
         }
         
     ## myhome to clip what do we do here TODO    
         foreach $o (keys %{$wh_hash}) {
            foreach $w (keys %{$wh_hash->{$o}}) {
               if ($wh_hash->{$o}->{$w} == '1') {
                  
                  `/www/sites/myhome/crons/xml_order_export.pl myhome $o`;
                  } else {
                  `/www/sites/myhome/crons/email_order_export.pl myhome $o`;
               }
            }
         }
         
         
         
         if ($ret_hash->{'FORM'}->{'next_page'}) {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            $ret_hash->{'DISPLAY'} = 'orderconf';
         }
         } else {
         if($ret_hash->{'ERROR'} =~ /REFUSAL/)
         {
            # the card was refused
            # the user shouldn't bother re-entering data and
            # trying again
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /DATA_ERROR/)
         {
            
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            
            # customer may have entered bad data
            # ask them to try again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /SYSTEM_ERROR/)
         {
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            # there was a server problem with the transaction
            # the user shouldn't bother re-entering data and
            # trying again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         
      }


 }
return $ret_hash;
   
   
   
   
   
   
   
   
}
sub pg_ordersummary {

   ## very simple page here, no approve just a display cell
   ## we set up the func to billto and run orderlist
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_ordersummary';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash->{'FORM'}->{'func'} = 'billto';
      $ret_hash =  &{$celllist->{'orderlist'}}($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash->{'mode'} = 'SHOW';
      
      $ret_hash->{'DISPLAY'} = 'billpay';
   }
   return $ret_hash;
}







sub pg_orderapprove {


   ###########
   # pg_orderapprove 		Billing list for approval
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields
   #	mode
   
   # Modes
   #	list
   #	approve
   
   # Cells
   #	cl_orderdisp
   
   # Function
   #	when aprove, check through payment.pm
   
   ###########
   
   
   ## this is a more indepth page as we need to handle different error messages
   ## then if everything is good, finish the order off
   
   my ($tmp_template);
   
   my $ret_hash = $_[0];
   #my $now;
   #$now=time();
   $ret_hash->{'template'} = 'page_checkout_orderapprove';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      
      ## the show bit is pretty simple here, just show the order list
      ## and the approve button
      
      $ret_hash->{'FORM'}->{'func'} = 'APPROVE';
      $ret_hash=&{$celllist->{'orderlist'}} ($ret_hash);
      
      $ret_hash=&{$celllist->{'orderapprove'}} ($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash = &{$celllist->{'orderapprove'}} ($ret_hash);
      
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
           
      
      if ($ret_hash->{'ERROR'} =~ /SUCCESS/){
         
         
         foreach $order ( @{$ret_hash->{'orderid_array'}} ) {
            my %FORM = %{$ret_hash->{'FORM'}};
            &tcart_to_ocart($ret_hash->{'sid'},$order,$ret_hash->{'custid'}, $nextwh, $testing ); #
            
            
            #create an event with a success in the dvalue
            $l="SELECT  wh FROM tcart where orderid='$order' ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            ($wh)=$stl->fetchrow;
            if (!$sidwh) {
               $sidwh=$wh;
            }
            $dvalue=$order."\t".$ret_hash->{'cyberoid'}."\tno\tuc\t".$ret_hash->{'STATUSDVALUE'};

            if ( $site->{'site_datadriver'} =~ /Oracle/ ) {
               $l="insert into levents (event,DTABLE,DVALUE,CDATE,custid) values(levents_event.nextval,'orders','$dvalue','$now','$ret_hash->{'custid'}') ";   
            } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {
               $l="INSERT INTO levents (DTABLE, DVALUE, CDATE,CUSTID) VALUES ('orders','$dvalue','$now','$ret_hash->{'custid'}')";
            } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {
                $l="INSERT INTO levents (event,DTABLE, DVALUE, CDATE,CUSTID) VALUES (NEXTVAL('event'),'orders','$dvalue','$now','$ret_hash->{'custid'}')";
            }                  

            $stl=$dbh->prepare($l);
            $stl->execute;
            $ok_proceed=1;
            
            
            
            $q="Select WH FROM ocart where orderid = '$order'";
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $num=$sth->rows;
#            for (1 .. $num) {
            while ( $wh = $sth->fetchrow ) {
#               $wh = $sth->fetchrow;
               $wh_hash->{$order}->{$wh} = 1;
            }
         }
         
     ## myhome to clip what do we do here TODO    
         foreach $o (keys %{$wh_hash}) {
            foreach $w (keys %{$wh_hash->{$o}}) {
               if ($wh_hash->{$o}->{$w} == '1') {
                  
                  `/www/sites/myhome/crons/xml_order_export.pl myhome $o`;
                  } else {
                  `/www/sites/myhome/crons/email_order_export.pl myhome $o`;
               }
            }
         }
         
         
         
         if ($ret_hash->{'FORM'}->{'next_page'}) {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            $ret_hash->{'DISPLAY'} = 'orderconf';
         }
         } else {
         if($ret_hash->{'ERROR'} =~ /REFUSAL/)
         {
            # the card was refused
            # the user shouldn't bother re-entering data and
            # trying again
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /DATA_ERROR/)
         {
            
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            
            # customer may have entered bad data
            # ask them to try again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /SYSTEM_ERROR/)
         {
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            # there was a server problem with the transaction
            # the user shouldn't bother re-entering data and
            # trying again
            $ret_hash->{'DISPLAY'} = 'orderapprove';
         }
         
      }
   }
   return $ret_hash;
   
   
   
}

sub pg_orderconf {

   ###########
   # pg_orderconf			Order Confermation
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	fields
   #	mode
   
   # Modes
   #	list
   #	approve
   
   # Cells
   #	cl_orderconf
   
   # Functions
   #	notifyorder
   
   # Function
   #
   
   ############
   
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_order_conf';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $tmp_form = '';
      foreach (@{$ret_hash->{'orderid_array'}}) {
         $ret_hash->{'orderid'}=$_;
         $tmp_form = sendemail ($ret_hash);
         
         $remplate = localize_template('cell_ck_finaldisp',$om_render_lang,$interface,0);
         $tmp_form->{'storeurl'}=$site->{'storeurl'};
         
         $ret_hash->{'FORM'}->{'textarea'}.= permutebit($remplate,$tmp_form);
      }
   }
   
   
   
   if (!$ret_hash->{'ERROR'} && $ret_hash->{'mode'} eq 'approve') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
      
      if ($ret_hash->{'FORM'}->{'next_page'}) {
         $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
         } else {
         $ret_hash->{'DISPLAY'} = 'shippingmethod';
      }
   }
   return $ret_hash;
   
   
   
}


sub pg_addressenter {


   ############
   # pg_addressenter		Address Enter Page
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	fields
   #	mode
   #
   
   # Modes
   #	list
   #	approve
   
   # Cells
   # 	Address Enter
   
   # Function
   #	Page to enter to change addresses anywhere
   
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_addressenter';
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
      
      
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
   }
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
      if (!$ret_hash->{'ERROR'}) {

		## I don't know why we would need another here, but I better check to make sure I must
		## have put it in for some reason

         if (!$ret_hash->{'orderid'}) {
            my $orderid;
           
            
            $f= " SELECT * FROM tcart where sid='$ret_hash->{'sid'}' and custid='$ret_hash->{'custid'}' \n";
            $stf= $dbh->prepare ($f);
            $stf->execute;
            
            $z=$stf->fetchrow_hashref(NAME_lc);
            $orderid=$z->{'orderid'};
            push (@{$ret_hash->{'orderid_array'}}, $orderid);        
            
            $q.="(objid,SID,custid,$ret_hash->{'func'},cdate,mdate,status) ";
            $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'addrid'}',";
            $q.="'$now','$now','ck') ";
            $sts = $dbh->prepare( $q );
            $sts->execute;
            $ret_hash->{'orderid'} = $orderid;
            
            } else {
            
            foreach $t (@{$ret_hash->{'orderid_array'}}) {
               
               $q = "update orders set $ret_hash->{'func'} = '$ret_hash->{'FORM'}->{'addrid'}' where objid = '$t' ";
#               $dbh->do($q);
               $sth = $dbh->prepare( $q );
               $sth->execute;
            }
         }
         
         
         if ($ret_hash->{'FORM'}->{'nextpage'})  {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            if ($ret_hash->{'FORM'}->{'func'} eq 'shipto') {
               $ret_hash->{'DISPLAY'} = 'shippingaddress';
               } else {
               $ret_hash->{'DISPLAY'} = 'billpay';
            }
         }
         } else {
         $ret_hash->{'DISPLAY'} = 'addressenter';
      }
   }
   return $ret_hash;
   
   
   
}




sub printtolog {
   
   my ($hash);
   $hash = $_[0];
   foreach $k (keys %{$hash}) {
      print  "key is $k val is $hash->{$k}<br>";
   }
}












sub sendemail {
   
   ## Local Vars:
   #     $thisord - hashref to entry from orders
   #     $formrows - hashref to order line items
   #
   # Copied from Checkout .0.7
   my($ret_hash, $u,$a,$o,%alist,$num,$q,$hi,$discount,$sts,$thisord,$temp );
   ## load the order information
   #
   $ret_hash = $_[0];
   $FORM = $ret_hash->{'FORM'};
   $FORM{'orderid'} = $ret_hash->{'orderid'};
   $FORM{'custid'} = $ret_hash->{'custid'};


   $q='SELECT * FROM orders where objid=';
   $q.="'$ret_hash->{'orderid'}' ";
   $sts = $dbh->prepare( $q );

   $sts->execute;
#   if ( $sts->rows > 0 ) {
   if ( $thisord=$sts->fetchrow_hashref(NAME_lc)) {
#      $thisord=$sts->fetchrow_hashref;  #later figure lineid's
      } else {                              # this is an error
      $thisord={};
      $FORM{'page_err'}.="Order $ret_hash->{'orderid'} not found! \n";
   } # done loading order from tables...



   ##saved info
   ## construct order summary cells
   #
   $myhome_orderid = $ret_hash->{'orderid'};
   $u=localize_template("cell_ck_300_finallist",$om_render_lang,$interface,0);
   $tfl=localize_template("cell_ck_text_finallist",$om_render_lang,$interface,0);


   $q='SELECT * FROM ocart where orderid='."'$ret_hash->{'orderid'}'";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   
#   $num=$sts->rows;
   $j=0;
   $discount=0;
#   foreach (1..$num) {
#      $h = $sts->fetchrow_hashref;
   while ( $h = $sts->fetchrow_hashref(NAME_lc) ) {    
      $q="SELECT title,objclass,ref_from FROM things where objid='$h->{'lineobjid'}'";
      $sth = $dbh->prepare( $q );
      $sth->execute;
#      if ( $sth->rows==1 ) {
      if ( ($h->{'title'},$h->{'objclass'},$h->{'ref_from'}) =  $sth->fetchrow ) {
#         ($h->{'title'},$h->{'objclass'},$h->{'ref_from'}) =  $sth->fetchrow ;

         ## pulling title and plaintext from master sku for variant product
         #

         $vardescript="";
         $vcode="";

         if ( $h->{'lineobjid'} ne $h->{'ref_from'} && $h->{'ref_from'} ) {
            $vcode = $h->{'vcode'};
            $q="SELECT * from things where objid='$h->{'ref_from'}' ";
            $stq=$dbh->prepare( $q );
            $stq->execute;
            $mh=$stq->fetchrow_hashref(NAME_lc);

                @vcodes = split /:/, $vcode;
                @axisname = split /:/, $mh->{'axisnames'};
                foreach $axis (@axisname) {
                   $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                   $stl=$dbh->prepare($s);
                   $stl->execute;
                   ($body)=$stl->fetchrow;
                   @valuepairs = split /\r\n/, $body;
                   foreach $pair (@valuepairs) {
                      ($key,$value) = split/:/, $pair;
                      $variant{$key}=$value;
                   }
                $code = shift @vcodes;
                $vardescript.=" ".$variant{$code};
                }
                $h->{'title'} = $mh->{'title'}.$vardescript;

         } 

      } # done getting the title...

      ## Class diplay issues
      if ($h->{'objclass'} eq '140-A') { #shipping method
         $thisord->{'shipcost'} = $h->{'linetotal'};
         $thisord->{'ship_via'} = $h->{'title'};
         next;
      } elsif ($h->{'objclass'} ne '134-A') {
         next;
      }

      $h->{'linetotal'} = nicedecimals($h->{'linetotal'});

      $o.= permutebit( $u, $h );
      $discount += $h->{'linetotal'} if ($h->{'objclass'} eq 'PRO');
      $txt.= permutebit( $tfl, $h );
      $txt[$j]=$h;
      $j++;
   } #
   $thisord->{'custid'} = $FORM{'custid'};
   ## now have tax, subtotal,etc..
   #

   ## we need the users email address

   $q = "SELECT uname FROM contacts where objid='$ret_hash->{'custid'}'";
   $sth=$dbh->prepare($q);
   $sth->execute;
#   if ($sth->rows > 0) {
   if ( $thisord->{'u_email'} = $sth->fetchrow ) {
#      $thisord->{'u_email'} = $sth->fetchrow;
   }
   $FORM{'cell_ck_finallist'}=$o;
   $FORM{'cell_ck_text_finallist'}=$txt;
   $thisord->{'subtotal'}=nicedecimals($thisord->{'st_nontax'} + $thisord->{'st_taxable'}+$discount);
   $thisord->{'subtotal_disc'}=$thisord->{'subtotal'} ;
   ## fix number of zeros after the decimal point for some fields
   #


#   $thisord->{'taxraten'}=$thisord->{'taxrate'};
   $thisord->{'taxraten'}=$site->{'taxrate'};
   foreach $k ( "subtotal_disc", "st_nontax","st_tax","shipcost","ordtotal","subtotal", "st_taxable", "taxraten" ) {
      $thisord->{$k} = nicedecimals( $thisord->{$k});
   } # done with decimal point cleanup...


   $thisord->{'SHIPCOST'}="Free!" if ( ($thisord->{'SHIPCOST'}/1) == 0 );
   if ($thisord->{'SHIPCOST'} > 0) {
      $thisord->{'SHIPCOST'}="\$".$thisord->{'SHIPCOST'};
   }
   
   $thisord->{'subtotal1'}=nicedecimals($FORM{'subtotal1'});
   #$FORM{'TAXRATEN'}.="%";
   ## now the body of the order
   #
      
   if ( length($ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCID_inp'}) < 5) {
      $thisord->{'CCID'}="N/A";
      $thisord->{'CCEXPMO'}="N";
      $thisord->{'CCEXPYR'}="A";
   } else {
      $thisord->{'CCID'}=substr($ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCID_inp'},-5);
      $thisord->{'CCNAME'}=$ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCNAME_inp'};
      $thisord->{'CCEXPMO'}=$ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCEXPMO_inp'};
      $thisord->{'CCEXPYR'}=$ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCEXPYR_inp'};
   }


   ## permute the HTML Page

   $thisord->{'OID'} = $myhome_orderid;
   
   $thisord->{'custid'} = $FORM{'custid'};
   $o=localize_template("cell_ck_300_finalhdr",$om_render_lang,$interface,0);
   $FORM{'cell_ck_finalhdr'} = permutebit( $o, $thisord );
   $o=localize_template("cell_ck_300_subtotal",$om_render_lang,$interface,0);
   $FORM{'cell_ck_subtotal'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_taxtotal",$om_render_lang,$interface,0);
   $FORM{'cell_ck_taxtotal'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_shipcost",$om_render_lang,$interface,0);
   $FORM{'cell_ck_shipcost'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_totalcost",$om_render_lang,$interface,0);
   $FORM{'cell_ck_totalcost'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_subtotal_discount",$om_render_lang,$interface,0);
   $FORM{'cell_ck_subtotal_discount'} = permutebit( $o, $thisord );
   
   $FORM{'perdiscount'}=100*(1-$discount);
   #	$FORM{'cell_ck_final_discount'}=permutebit($FORM{'cell_ck_300_final_discount'},\%FORM);
   
   if ($discount==1.00) {
      $FORM{'cell_ck_final_discount'}="";
      $FORM{'cell_ck_subtotal_discount'}="";
   }
   
   
   ## now format the text template page
   #
   $txt = localize_template("cell_ck_text_giftcert",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_giftcert'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_subtotal",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_subtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_subtotal",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_subtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_taxtotal",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_taxtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_shipcost",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_shipcost'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_totalcost",$om_render_lang,$interface,0);
   $FORM{'cell_ck_text_totalcost'} = permutebit( $txt, $thisord );
   #	$txt = localize_template("cell_ck_text_subtotal_discount",$om_render_lang,$interface,0);
   #	$FORM{'cell_ck_text_subtotal_discount'} = permutebit( $txt, $thisord );
   
   if ($discount==1.00) {
      #		$FORM{'cell_ck_text_subtotal_discount'}="";
   }
   
   ## the payment information cell...
   #     and all it's little bits...
   ## done constructing the payment cell...
   ## payment info is not sent via email
   ## the billing address cell


   $q="SELECT * FROM addresses where objid='$thisord->{'billto'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $bhp= $stc->fetchrow_hashref(NAME_lc);
   ($fname,$lname,$ltite) = split /\|/, $bhp->{'name'};
   $bhp->{'name'} = $fname .' '. $lname;
   $bhp->{'name'} = $ltite . ' ' .$fname .' '. $lname if ( $ltite );
   #print "q is $q<br>"; 
#   if ( $stc->rows == 1 ) {
   if ( $bhp ) {
      $FORM{'cell_ck_billaddr'} =
      localize_template("cell_ck_text_displayaddr",$om_render_lang,$interface,0);
      $FORM{'cell_ck_text_billaddr'} =
      localize_template("cell_ck_text_displayaddr",$om_render_lang,$interface,0);
      $FORM{'cell_ck_billaddr'} =
      permutebit( $FORM{'cell_ck_billaddr'}, $bhp );
      $FORM{'cell_ck_text_billaddr'} =
      permutebit( $FORM{'cell_ck_text_billaddr'}, $bhp );
   } # end of address load
   ## the shipping address cell
   $q="SELECT * FROM addresses where objid='$thisord->{'shipto'}' ";

   $stc = $dbh->prepare( $q );
   $stc->execute;
   $shp= $stc->fetchrow_hashref(NAME_lc);
   ($fname,$lname,$ltite) = split /\|/, $shp->{'name'};
   $shp->{'name'} = $fname .' '. $lname;
   $shp->{'name'} = $ltite . ' ' .$fname .' '. $lname if ($ltite);   
   
   
#   if ( $stc->rows == 1 ) {
   if ( $shp ) {
      $FORM{'cell_ck_shipaddr'} =
      localize_template("cell_ck_text_displayaddr",$om_render_lang,$interface,0);
      $FORM{'cell_ck_text_shipaddr'} =
      localize_template("cell_ck_text_displayaddr",$om_render_lang,$interface,0);
      $FORM{'cell_ck_shipaddr'} =
      permutebit( $FORM{'cell_ck_shipaddr'}, $shp );
      $FORM{'cell_ck_text_shipaddr'} =
      permutebit( $FORM{'cell_ck_text_shipaddr'}, $shp );
   } # end of address load
   
   $FORM{'cell_ck_shipcost'} = permutebit( $FORM{'cell_ck_shipcost'}, \%FORM );
   
   
   # end of ship method
#   $q= "SELECT title FROM things where objid='$FORM{'DELIVERY'}' ";
#   $stc = $dbh->prepare( $q );
#   $stc->execute;
#   $spm= $stc->fetchrow_hashref;
#   if ( $stc->rows == 1 ) {
#      $FORM{'DELIVERY'} = "$spm->{'TITLE'}";
#   } # end of ship method
   $textpage=localize_template("page_ck_e-conf",$om_render_lang,$interface,0);
   $textpagebot=localize_template("page_ck_e-conf_bottom",$om_render_lang,$interface,0);
   ## spit the file to stdout
   #
   $FORM{'sitename'}=$site->{'sitename'};
   $FORM{'order_email_address'}=$site->{'order_email_address'};
   $textpage = permutebit( $textpage, \%FORM );
   $textpage = permutebit( $textpage, $store_env );
   $textpage = permutebit( $textpage, \%ENV );
   $textpage=permutebit($textpage,$thisord);
   $textpagebot=permutebit( $textpagebot, \%FORM);
   $textpagebot=permutebit( $textpagebot, $store_env );
   $textpagebot=permutebit( $textpagebot, \%ENV );
   $textpagebot=permutebit( $textpagebot, $thisord);
   $textpagebot=permuteclean( $textpagebot );
   $nothing="            ";
   $textpage=~ s/<PRE>/$nothing/gms;
   ## load remaining ORDER vars into FORM
   foreach ( keys %{$thisord} ) {
      $FORM{$_} = $thisord->{$_};
   };
   
   ## send the email to customer and orders
   
#   $mailprog = '/usr/sbin/sendmail';
   $mailprog = $site->{'mailserver'};
   if ( $mailprog ) {
      $title= "Your $site->{'sitename'} order";
      # Open The Mail Program
      open(MAIL,"|$mailprog -t");
#   open(MAIL,">/tmp/email.txt");
      print MAIL "To: $FORM{'u_email'} \n";
      print MAIL "From: $site->{'order_email_address'}\n";
      print MAIL "Bcc: $site->{'order_email_address'}\n";
      print MAIL "Subject: $title\n\n";
      print MAIL "$textpage\n";
      print MAIL "SKU\tQty\tPrice\tProduct\n\n";
      foreach $line (@txt) {
         print MAIL "$line->{'msku'}\t$line->{'quant'}\t\$$line->{'unitpr'}\t$line->{'title'}\n";
         if ($line->{'msku'} =~ /gct/ ) {
            push @giftemail, $line;
         }
      }
      $textpagebot=~ s/<br>//gms;
      $textpagebot=~ s/<\/FONT>//gms;
      $textpagebot=~ s/<FONT FACE=\"arial, helvetica\" SIZE=-1>//gms;
      print MAIL "\n\n$textpagebot\n";
      close (MAIL);
   }
   return \%FORM;
   
   
   
} #/make_pg_4

1;









